



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>用node编写cli工具</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">用node编写cli工具</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-03-25 08:39:21 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p>cli是command-line interface的缩写，即命令行工具，常用的<em>vue-cli</em>， <em>create-react-app</em>， <em>express-generator</em> 等都是cli工具。</p>
<p>本文以自己开发my-cli为例，将开发到发布过程完整记录下来，看完本文，你将学会如何从零开发一个cli项目，如何上传到github库，以及如何使用npm发布自己的包。</p>
<h3>准备</h3>
<p>开发一个cli工具前首先要想好它能做什么。以我自己为例，我需要一个工具，让我能只输入一行命令就帮我快速搭建好项目结构，就像这样：<br /><br />
<img referrerpolicy="no-referrer"src="http://ooqymz3vm.bkt.clouddn.com/cli1.gif"><br /><br />
是不是很炫酷？放心，很简单。</p>
<h3>开始</h3>
<p>首先创建你的cli项目，并使用npm init创建一个package.json。</p>
<pre class="prettyprint linenums"><code>$ mkdir my-cli &amp;&amp; cd my-cli<br />
$ npm init<br />
</code></pre>
<p>根据提示一步步创建好package.json。name属性就是你发布到npm上的名字，这个是不能与npm上现有项目重名的，一个小技巧是使用npm info查看你想要起的包名字，如果报错404，那么你的包名是可用的。最后创建好的package.json文件像这样子：</p>
<pre class="prettyprint linenums"><code>{<br />
  &quot;name&quot;: &quot;my-cli&quot;,<br />
  &quot;version&quot;: &quot;0.0.1&quot;,<br />
  &quot;description&quot;: &quot;Auto generate project template&quot;,<br />
  &quot;main&quot;: &quot;index.js&quot;,<br />
  &quot;bin&quot;: {<br />
    &quot;my-cli&quot;: &quot;./index.js&quot;<br />
  },<br />
  &quot;repository&quot;: {<br />
    &quot;type&quot;: &quot;git&quot;,<br />
    &quot;url&quot;: &quot;git+https://github.com/hlme/my-cli.git&quot;<br />
  },<br />
  &quot;keywords&quot;: [<br />
    &quot;cli&quot;<br />
  ],<br />
  &quot;author&quot;: &quot;798400626@qq.com&quot;,<br />
  &quot;license&quot;: &quot;MIT&quot;,<br />
  &quot;bugs&quot;: {<br />
    &quot;url&quot;: &quot;https://github.com/hlme/my-cli/issues&quot;<br />
  },<br />
  &quot;homepage&quot;: &quot;https://github.com/hlme/my-cli#readme&quot;<br />
}<br />
</code></pre>
<h3>编写可执行文件</h3>
<p>package.json中有一个&quot;bin&quot;字段，配置后才可以在控制台使用你的命令。</p>
<pre class="prettyprint linenums"><code>&quot;bin&quot;: {<br />
  &quot;my-cli&quot;: &quot;./index.js&quot;<br />
}<br />
</code></pre>
<p>我们配置了&quot;my-cli&quot;命令来执行index.js文件。用你喜欢的编辑器，在项目主目录下创建一个index.js文件。<br /><br />
<img referrerpolicy="no-referrer"src="https://images2015.cnblogs.com/blog/1150501/201705/1150501-20170522131945882-1522708990.png"><br /><br />
注意第一行的&quot;#! node&quot;很重要，表示用node来执行这个文件。如果没有这句声明，就会在记事本中打开index.js文件。补充：linux/unix 下应该是#!/usr/bin/env node，参考这篇<a href="https://zhidao.baidu.com/question/134547332.html" rel="external nofollow noreferrer">百度知道</a></p>
<h3>全局安装你的包</h3>
<p>使用 npm install -g 将你当前的项目安装到全局环境,现在你可以在命令行使用&quot;my-cli&quot;命令了。<br /><br />
<img referrerpolicy="no-referrer"src="https://images2015.cnblogs.com/blog/1150501/201705/1150501-20170522133313788-1604516323.png"></p>
<h3>用fs模块快速生成项目模板</h3>
<p>我们自定义的指令可以执行了，接下来编写代码实现功能。my-cli的主要功能就是生成项目模板，一个思路是用一个templates文件夹保存项目模板，然后通过fs.mkdir()来创建项目目录，最后把文件从templates文件夹拷贝到项目中去。</p>
<pre class="prettyprint linenums"><code>var fs = require('fs');<br />
var path = require('path');

function copyTemplate (from, to) {<br />
  from = path.join(__dirname, 'templates', from);<br />
  write(to, fs.readFileSync(from, 'utf-8'))<br />
}<br />
function write (path, str, mode) {<br />
  fs.writeFileSync(path, str)<br />
}<br />
function mkdir (path, fn) {<br />
  fs.mkdir(path, function (err) {<br />
    fn &amp;&amp; fn()<br />
  })<br />
}<br />
</code></pre>
<p>核心代码就这么点，是不是非常简单？</p>
<p>整个项目文件结构差不多就这个样子，把你需要的文件放到templates文件夹，然后用copyTemplate方法将文件拷贝到项目目录下。<br /><br />
<img referrerpolicy="no-referrer"src="https://images2015.cnblogs.com/blog/1150501/201705/1150501-20170522141007320-204854793.png"></p>
<p>创建文件目录和拷贝文件的过程，代码看着比较丑陋<br /><br />
<img referrerpolicy="no-referrer"src="https://images2015.cnblogs.com/blog/1150501/201705/1150501-20170522140747601-984317312.png"></p>
<h3>接收命令行参数</h3>
<p>平常我们使用命令行工具时都会用到参数，如 webpack -p, express -e 等，现在我们来为自己的cli添加接收命令行参数的功能。为my-cli设计四个参数，用来向项目中添加类库。</p>
<pre class="prettyprint linenums"><code>$ my-cli -j -s -v -b<br />
//-j :添加jQuery<br />
//-s :添加Swiper<br />
//-v :添加Vue<br />
//-b :添加Bootstrap<br />
</code></pre>
<p>使用commander包可以方便的解析命令行参数，但是本项目不打算引入其他依赖，顺便学习如何手动解析命令行参数。<br /><br />
我们可以使用process.argv来获取命令行参数，process.argv是一个参数数组，第一项为node.exe的绝对路径，第二项为执行该js的绝对路径，使用process.argv.slice(2)即可获取输入的参数数组。</p>
<p><img referrerpolicy="no-referrer"src="https://images2015.cnblogs.com/blog/1150501/201705/1150501-20170522142632898-1585118250.png"><br /><br />
通过遍历参数数组来检查命令中输入了哪些参数。如果输入了预设的参数，就为config对象添加对应的属性，在生成文件时根据onfig判断是否将模板文件拷贝到项目中。继续丑陋的代码：<br /><br />
<img referrerpolicy="no-referrer"src="https://images2015.cnblogs.com/blog/1150501/201705/1150501-20170522142902757-1585121991.png"></p>
<h3>本地运行</h3>
<p>至此我们的项目已经基本完成了，使用 npm install -g 将项目安装到全局环境，然后新建一个项目文件夹，使用my-cli命令来生成项目模板。<br /><br />
<img referrerpolicy="no-referrer"src="https://images2015.cnblogs.com/blog/1150501/201705/1150501-20170522162756148-47839127.png"></p>
<h3>发布到npm仓库</h3>
<p>要想将自己的包发布到npm上，首先得有一个npm账号，创建账号非常简单，输入npm adduser，简单三步即可完成创建。<br /><br />
<img referrerpolicy="no-referrer"src="https://images2015.cnblogs.com/blog/1150501/201705/1150501-20170522143107757-1996993063.png"><br /><br />
创建好user后，使用npm publish即可将当前项目发布到npm上了，以后就可以使用npm install -g my-cli 来安装你的cli工具。<br /><br />
<img referrerpolicy="no-referrer"src="https://images2015.cnblogs.com/blog/1150501/201705/1150501-20170522153546257-1679238706.png"></p>
<h3>上传到github</h3>
<p>开发了自己的npm包，如果想获得更多人的关注，上传到github上是个比较好的办法，推荐一篇教程：<a href="http://www.runoob.com/git/git-remote-repo.html" rel="external nofollow noreferrer">GitHub 教程</a>。</p>
<h3>结束语</h3>
<p>相信大家看完本文后知道如何根据自己的需求制作cli工具了。本文中的my-cli功能比较简单，只为做一个简单的例子。查看源码可以点这里：<a href="https://github.com/yeild/my-cli" rel="external nofollow noreferrer">my-cli</a>。<br /><br />
更加实用一点的有 <a href="https://github.com/yeild/init-react" rel="external nofollow noreferrer">init-react</a> - 参考vue-cli开发的react项目生成工具，主要考虑create-react-app生成的项目隐藏了配置不方便修改，eject后又过于混乱。。（逃）</p>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/jqd53309.html">Pyqt 国际化多语言支持</a>
		</li>
						<li><a href="https://www.batexi.com/a/xq4noz39.html">React Native 一个组件styles BUG</a>
		</li>
						<li><a href="https://www.batexi.com/a/r8m467r8.html">使用Redux管理你的React应用</a>
		</li>
						<li><a href="https://www.batexi.com/a/o8kxwojq.html">linux sed命令</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7mzr5gq.html">Java&mdash;&mdash;匿名内部类</a>
		</li>
						<li><a href="https://www.batexi.com/a/95xkmwm8.html">Apache HTTP Server mod&lowbar;session&lowbar;dbd模块mod&lowbar;session&lowbar;dbd&period;c 安全漏洞</a>
		</li>
						<li><a href="https://www.batexi.com/a/8k1y7r69.html">svg 文字</a>
		</li>
						<li><a href="https://www.batexi.com/a/8meeg56q.html">Java设计模式（七）策略模式 模板模式</a>
		</li>
						<li><a href="https://www.batexi.com/a/8kpjo669.html">Android NDK的C&plus;&plus;11标准支持</a>
		</li>
						<li><a href="https://www.batexi.com/a/90mk4gm8.html">Tickets</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4z53ee9.html">SSM框架中前端页面（AJAX&plus;Jquery&plus;spring mvc&plus;bootstrap）</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1rwvg68.html">Object&period;assign&lpar;&rpar;怎么用？</a>
		</li>
						<li><a href="https://www.batexi.com/a/qdwr3jv9.html">ABP框架系列之九：&lpar;Abp-Session-会话&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/qnvp5lx8.html">浙江财经大学第十五届大学生程序设计竞赛------B 烦恼先生打麻将</a>
		</li>
						<li><a href="https://www.batexi.com/a/qnv30p38.html">中国剩余定理 （POJ 1006）</a>
		</li>
						<li><a href="https://www.batexi.com/a/qdje2yvq.html">Java之路（一） 一切皆对象</a>
		</li>
						<li><a href="https://www.batexi.com/a/9020vkjq.html">ajax 基本语法</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwl3ojy9.html">c&plus;&plus;静态变量</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1v0zy6q.html">&lbrack;ZJOI2015&rsqb;幻想乡战略游戏&mdash;&mdash;动态点分治</a>
		</li>
						<li><a href="https://www.batexi.com/a/qlonj1eq.html">实验室项目&period;md</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/9rnzyddq.html">centos 7 安装jira 破解</a>
			</li>
						<li><a href="https://www.batexi.com/a/qnnm5gxq.html">关于Flume中Chanel&period;Selector&period;header解释</a>
			</li>
						<li><a href="https://www.batexi.com/a/q1vmlz5q.html">&amp;&num;39&semi;utf-8&amp;&num;39&semi; codec can&amp;&num;39&semi;t decode byte 0xbc in position 1182&colon; invalid start byte</a>
			</li>
						<li><a href="https://www.batexi.com/a/qve5ro19.html">jquery jqzoom插件练习</a>
			</li>
						<li><a href="https://www.batexi.com/a/q7ex26j9.html">Exp6  20155218 信息搜集与漏洞扫描</a>
			</li>
						<li><a href="https://www.batexi.com/a/q4pg3ynq.html">20155234 exp4 恶意代码分析</a>
			</li>
						<li><a href="https://www.batexi.com/a/qdj0xjzq.html">奔跑吧Linux</a>
			</li>
						<li><a href="https://www.batexi.com/a/963j4nn9.html">【最详细最完整】在Linux 下如何打包免安装的QT程序？</a>
			</li>
						<li><a href="https://www.batexi.com/a/953rnev8.html">Dynamics CRM2016  导入数据格式之xlsx的应用</a>
			</li>
						<li><a href="https://www.batexi.com/a/963jgzy9.html">CS100&period;1x-lab4&lowbar;machine&lowbar;learning&lowbar;student</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
